/*   RCS $Id: c167-ali.h,v 1.4 1997/10/06 12:29:51 c166 Rel c166 $							*/
/*  
** c167-ali.h -- Processor support for SAB C167 using ALIASES
**
** Copyright (c) 1991-95 Hightec EDV-Systeme GmbH  D-66386 St.Ingbert
**
**	@(#) c167-ali.h  3.1  01/28/95  
*/

/********************************************************************/
/*
**   This file offers you the possiblitiy to access SFRs, SFRBITs etc.
**   via ALIASES.
**
**   E.g. if you want to write in your program  SET_SFRBIT(MYBIT)
**   instead of SET_SFRBIT(IEN), to set the Interrupt enable bit of PSW,
**   you define an alias (MYBIT) for IEN. 
**   So the mechanism of this file will make it possible to access to 
**   IEN by writing SET_SFRBIT(MYBIT).
**
**   CAUTION:
**   Because the choosen mechanism uses the Preprocessor, it is very
**   important to differ between upper and lower case letters.
**   This means WHENEVER you use the alias version of "c166.h", you
**   have to use lowercase letters for SFRs or SFRBITs in 
**   assembler macros, such as SET_SFRBIT, SET_SFR_BITFIELD etc., you
**   must define the alias with the lower case letters to avoid 
**   substitution of the definition of the SFR.
**   E.g.
**   #define MY_PORTBIT    P3.1
**               will cause trouble because the macro definition of
**               P3 (#define P3  *(unsigned int *)0xffC4)  will also
**               be extended by the processor 
**
**   whereas :
**   #define MY_PORTBIT    p3.1
**              will result in the right substitution
**
**   Furthermore, you can only refer to SFRs via their lowercase names
**   E.g.
**   SET_SFR_BITFIELD(CCM0,0x0f,0x02)  will also cause trouble! 
**  
**   Use the lowercase name as in
**  
**   SET_SFR_BITFIELD(ccm0,0x0f,0x02)  
**  
*/

#ifndef __C167__
#define __C167__
#endif

#include <c166-ali.h>

