/*   RCS $Id: c167.h,v 1.4 1997/10/06 12:29:50 c166 Rel c166 $							*/
/*
** c167.h -- Processor support for SAB C167
**
** Copyright (c) 1992-95 Hightec EDV-Systeme GmbH  D-66386 St.Ingbert
**
**      @(#) c167.h  3.1  01/28/95  
*/

#if ! defined c166_h
#define c166_h

#ifdef  __STRICT_ANSI__                         
#define asm     __asm__
#define inline  __inline__
#define typeof  __typeof__
#endif

#include <c16x.h>    /* commonly used definitions */

#endif  /* ! defined c166_h */

#if (defined __C166__ && defined __C167__)
/* Data page and code segment pointers */

#define         DPP0    (*(unsigned int volatile *)0xFE00)
#define         DPP1    (*(unsigned int volatile *)0xFE02)
#define         DPP2    (*(unsigned int volatile *)0xFE04)
#define         DPP3    (*(unsigned int volatile *)0xFE06)
#define         CSP     (*(unsigned int volatile *)0xFE08)

/* CPU system registers */

#define         MDH     (*(unsigned int volatile *)0xFE0C)
#define         MDL     (*(unsigned int volatile *)0xFE0E)
#define         MDC     (*(unsigned int volatile *)0xFF0E)
#define         CP      (*(unsigned int volatile *)0xFE10)
#define         SP      (*(unsigned int volatile *)0xFE12)
#define         STKOV   (*(unsigned int volatile *)0xFE14)
#define         STKUN   (*(unsigned int volatile *)0xFE16)
#define         WDT     (*(unsigned int volatile *)0xFEAE)

/* Timer registers */

#if !(defined C165 || defined __C165__)
#define         T01CON          (*(unsigned int volatile *)0xFF50)
#define         T0IC            (*(unsigned int volatile *)0xFF9C)
#define         T1IC            (*(unsigned int volatile *)0xFF9E)
#endif
#define         T2IC            (*(unsigned int volatile *)0xFF60)
#define         T2CON           (*(unsigned int volatile *)0xFF40)
#define         T3IC            (*(unsigned int volatile *)0xFF62)
#define         T3CON           (*(unsigned int volatile *)0xFF42)
#define         T4IC            (*(unsigned int volatile *)0xFF64)
#define         T4CON           (*(unsigned int volatile *)0xFF44)
#define         T5IC            (*(unsigned int volatile *)0xFF66)
#define         T5CON           (*(unsigned int volatile *)0xFF46)
#define         T6IC            (*(unsigned int volatile *)0xFF68)
#define         T6CON           (*(unsigned int volatile *)0xFF48)

#if !(defined C165 || defined __C165__)
#define         T7IC            (*(unsigned int volatile *)0xF17A)
#define         T7REL           (*(unsigned int volatile *)0xF054)
#define         T8IC            (*(unsigned int volatile *)0xF17C)
#define         T8REL           (*(unsigned int volatile *)0xF056)
#define         T78CON          (*(unsigned int volatile *)0xFF20)
#endif

#define         T2      (*(unsigned int volatile *)0xFE40)
#define         T3      (*(unsigned int volatile *)0xFE42)
#define         T4      (*(unsigned int volatile *)0xFE44)
#define         T5      (*(unsigned int volatile *)0xFE46)
#define         T6      (*(unsigned int volatile *)0xFE48)

#if !(defined C165 || defined __C165__)
#define         T7      (*(unsigned int volatile *)0xF050)
#define         T8      (*(unsigned int volatile *)0xF052)

#define         T0      (*(unsigned int volatile *)0xFE50)
#define         T1      (*(unsigned int volatile *)0xFE52)
#define         T0REL   (*(unsigned int volatile *)0xFE54)
#define         T1REL   (*(unsigned int volatile *)0xFE56)
#endif



/* CAPCOM registers */

#if !(defined C165 || defined __C165__)
#define         CC0     (*(unsigned int volatile *)0xFE80)
#define         CC1     (*(unsigned int volatile *)0xFE82)
#define         CC2     (*(unsigned int volatile *)0xFE84)
#define         CC3     (*(unsigned int volatile *)0xFE86)
#define         CC4     (*(unsigned int volatile *)0xFE88)
#define         CC5     (*(unsigned int volatile *)0xFE8A)
#define         CC6     (*(unsigned int volatile *)0xFE8C)
#define         CC7     (*(unsigned int volatile *)0xFE8E)
#define         CC8     (*(unsigned int volatile *)0xFE90)
#define         CC9     (*(unsigned int volatile *)0xFE92)
#define         CC10    (*(unsigned int volatile *)0xFE94)
#define         CC11    (*(unsigned int volatile *)0xFE96)
#define         CC12    (*(unsigned int volatile *)0xFE98)
#define         CC13    (*(unsigned int volatile *)0xFE9A)
#define         CC14    (*(unsigned int volatile *)0xFE9C)
#define         CC15    (*(unsigned int volatile *)0xFE9E)

#define         CC16    (*(unsigned int volatile *)0xFE60)
#define         CC17    (*(unsigned int volatile *)0xFE62)
#define         CC18    (*(unsigned int volatile *)0xFE64)
#define         CC19    (*(unsigned int volatile *)0xFE66)
#define         CC20    (*(unsigned int volatile *)0xFE68)
#define         CC21    (*(unsigned int volatile *)0xFE6A)
#define         CC22    (*(unsigned int volatile *)0xFE6C)
#define         CC23    (*(unsigned int volatile *)0xFE6E)
#define         CC24    (*(unsigned int volatile *)0xFE70)
#define         CC25    (*(unsigned int volatile *)0xFE72)
#define         CC26    (*(unsigned int volatile *)0xFE74)
#define         CC27    (*(unsigned int volatile *)0xFE76)
#define         CC28    (*(unsigned int volatile *)0xFE78)
#define         CC29    (*(unsigned int volatile *)0xFE7A)
#define         CC30    (*(unsigned int volatile *)0xFE7C)
#define         CC31    (*(unsigned int volatile *)0xFE7E)

/* ADC result register */

#define         ADDAT   (*(unsigned int volatile *)0xFEA0)
#define         ADDAT2  (*(unsigned int volatile *)0xF0A0)
#endif

/* Serial channels */

#define         S0TBUF  (*(unsigned int volatile *)0xFEB0)
#define         S0RBUF  (*(unsigned int volatile *)0xFEB2)
#define         S0BG    (*(unsigned int volatile *)0xFEB4)
#define         S0TIC   (*(unsigned int volatile *)0xFF6C)
#define         S0TBIC  (*(unsigned int volatile *)0xF19C)
#define         S0RIC   (*(unsigned int volatile *)0xFF6E)
#define         S0EIC   (*(unsigned int volatile *)0xFF70)
#define         S1TBUF  (*(unsigned int volatile *)0xFEB8)
#define         S1RBUF  (*(unsigned int volatile *)0xFEBA)
#define         S1BG    (*(unsigned int volatile *)0xFEBC)
#define         S1TIC   (*(unsigned int volatile *)0xFF72)
#define         S1RIC   (*(unsigned int volatile *)0xFF74)
#define         S1EIC   (*(unsigned int volatile *)0xFF76)

/* PEC channels */

#define         PECC0    (*(unsigned int volatile *)0xFEC0)
#define         PECC1    (*(unsigned int volatile *)0xFEC2)
#define         PECC2    (*(unsigned int volatile *)0xFEC4)
#define         PECC3    (*(unsigned int volatile *)0xFEC6)
#define         PECC4    (*(unsigned int volatile *)0xFEC8)
#define         PECC5    (*(unsigned int volatile *)0xFECA)
#define         PECC6    (*(unsigned int volatile *)0xFECC)
#define         PECC7    (*(unsigned int volatile *)0xFECE)

/*** Accessing SFRs (bitaddressable) ******************************************/

/* System configuration register */

#define         SYSCON          (*(unsigned int volatile *)0xFF12)

/* Processor status word */

#define         PSW     (*(unsigned int volatile *)0xFF10)

/* Constant registers */

#define         ZEROS   (*(unsigned int volatile *)0xFF1C)
#define         ONES    (*(unsigned int volatile *)0xFF1E)

/* CAPCOM mode control registers */

#if !(defined C165 || defined __C165__)
#define         CCM0            (*(unsigned int volatile *)0xFF52)
#define         CCM1            (*(unsigned int volatile *)0xFF54)
#define         CCM2            (*(unsigned int volatile *)0xFF56)
#define         CCM3            (*(unsigned int volatile *)0xFF58)
#define         CCM4            (*(unsigned int volatile *)0xFF22)
#define         CCM5            (*(unsigned int volatile *)0xFF24)
#define         CCM6            (*(unsigned int volatile *)0xFF26)
#define         CCM7            (*(unsigned int volatile *)0xFF28)
#endif

#define         CAPREL  	(*(unsigned int volatile *)0xFE4A)

/*  CAPCOM interrupt control registers */

#define         CRIC            (*(unsigned int volatile *)0xFF6A)
#if !(defined C165 || defined __C165__)
#define         CC0IC           (*(unsigned int volatile *)0xFF78)
#define         CC1IC           (*(unsigned int volatile *)0xFF7A)
#define         CC2IC           (*(unsigned int volatile *)0xFF7C)
#define         CC3IC           (*(unsigned int volatile *)0xFF7E)
#define         CC4IC           (*(unsigned int volatile *)0xFF80)
#define         CC5IC           (*(unsigned int volatile *)0xFF82)
#define         CC6IC           (*(unsigned int volatile *)0xFF84)
#define         CC7IC           (*(unsigned int volatile *)0xFF86)
#endif
#define         CC8IC           (*(unsigned int volatile *)0xFF88)
#define         CC9IC           (*(unsigned int volatile *)0xFF8A)
#define         CC10IC          (*(unsigned int volatile *)0xFF8C)
#define         CC11IC          (*(unsigned int volatile *)0xFF8E)
#define         CC12IC          (*(unsigned int volatile *)0xFF90)
#define         CC13IC          (*(unsigned int volatile *)0xFF92)
#define         CC14IC          (*(unsigned int volatile *)0xFF94)
#define         CC15IC          (*(unsigned int volatile *)0xFF96)

#if !(defined C165 || defined __C165__)
#define         CC16IC  	(*(unsigned int volatile *)0xF160)
#define         CC17IC  	(*(unsigned int volatile *)0xF162)
#define         CC18IC  	(*(unsigned int volatile *)0xF164)
#define         CC19IC  	(*(unsigned int volatile *)0xF166)
#define         CC20IC  	(*(unsigned int volatile *)0xF168)
#define         CC21IC  	(*(unsigned int volatile *)0xF16A)
#define         CC22IC  	(*(unsigned int volatile *)0xF16C)
#define         CC23IC  	(*(unsigned int volatile *)0xF16E)
#define         CC24IC  	(*(unsigned int volatile *)0xF170)
#define         CC25IC  	(*(unsigned int volatile *)0xF172)
#define         CC26IC  	(*(unsigned int volatile *)0xF174)
#define         CC27IC  	(*(unsigned int volatile *)0xF176)
#define         CC28IC  	(*(unsigned int volatile *)0xF178)
#endif
#define         CC29IC  	(*(unsigned int volatile *)0xF184)
#define         CC30IC  	(*(unsigned int volatile *)0xF18C)
#define         CC31IC  	(*(unsigned int volatile *)0xF194)

#if !(defined C165 || defined __C165__)
#define         ADCIC           (*(unsigned int volatile *)0xFF98)
#define         ADEIC           (*(unsigned int volatile *)0xFF9A)

/* ADC control register */

#define         ADCON           (*(unsigned int volatile *)0xFFA0)
#endif

#define         P5              (*(unsigned int volatile *)0xFFA2)

/* Trap function register */

#define         TFR             (*(unsigned int volatile *)0xFFAC)

/* Watchdog timer control register */

#define         WDTCON          (*(unsigned int volatile *)0xFFAE)

/* Serial channel control registers */

#define         S0CON           (*(unsigned int volatile *)0xFFB0)
#define         S1CON           (*(unsigned int volatile *)0xFFB8)

/* Port data and control registers */

#define         P0L      	(*(unsigned int volatile *)0xFF00)
#define         P0H      	(*(unsigned int volatile *)0xFF02)
#define         P1L      	(*(unsigned int volatile *)0xFF04)
#define         P1H      	(*(unsigned int volatile *)0xFF06)

#define         P2              (*(unsigned int volatile *)0xFFC0)
#define         P3              (*(unsigned int volatile *)0xFFC4)
#define         P4              (*(unsigned int volatile *)0xFFC8)
#define         P5              (*(unsigned int volatile *)0xFFA2)
#define         P6              (*(unsigned int volatile *)0xFFCC)

#if !(defined C165 || defined __C165__)
#define         P7              (*(unsigned int volatile *)0xFFD0)
#define         P8              (*(unsigned int volatile *)0xFFD4)
#endif

#define         DP0L            (*(unsigned int volatile *)0xF100)
#define         DP0H            (*(unsigned int volatile *)0xF102)
#define         DP1L            (*(unsigned int volatile *)0xF104)
#define         DP1H            (*(unsigned int volatile *)0xF106)
#define         DP2             (*(unsigned int volatile *)0xFFC2)
#define         DP3             (*(unsigned int volatile *)0xFFC6)

#define         DP4             (*(unsigned int volatile *)0xFFCA)
#define         DP6             (*(unsigned int volatile *)0xFFCE)
#if !(defined C165 || defined __C165__)
#define         DP7             (*(unsigned int volatile *)0xFFD2)
#define         DP8             (*(unsigned int volatile *)0xFFD6)
#endif

#define         ODP2            (*(unsigned int volatile *)0xF1C2)
#define         ODP3            (*(unsigned int volatile *)0xF1C6)
#define         ODP6            (*(unsigned int volatile *)0xF1CE)
#if !(defined C165 || defined __C165__)
#define         ODP7            (*(unsigned int volatile *)0xF1D2)
#define         ODP8            (*(unsigned int volatile *)0xF1D6)
#endif

/* PEC pointers */

#define SRCP0   (*(unsigned int volatile *)0xfce0)  /* Source Pointer PECC 0*/
#define DSTP0   (*(unsigned int volatile *)0xfce2)  /* Destination Pointer 0*/
#define SRCP1   (*(unsigned int volatile *)0xfce4)  /* Source Pointer PECC 1*/
#define DSTP1   (*(unsigned int volatile *)0xfce6)  /* Destination Pointer 1*/
#define SRCP2   (*(unsigned int volatile *)0xfce8)  /* Source Pointer PECC 2*/
#define DSTP2   (*(unsigned int volatile *)0xfcea)  /* Destination Pointer 2*/
#define SRCP3   (*(unsigned int volatile *)0xfcec)  /* Source Pointer PECC 3*/
#define DSTP3   (*(unsigned int volatile *)0xfcee)  /* Destination Pointer 3*/
#define SRCP4   (*(unsigned int volatile *)0xfcf0)  /* Source Pointer PECC 4*/
#define DSTP4   (*(unsigned int volatile *)0xfcf2)  /* Destination Pointer 4*/
#define SRCP5   (*(unsigned int volatile *)0xfcf4)  /* Source Pointer PECC 5*/
#define DSTP5   (*(unsigned int volatile *)0xfcf6)  /* Destination Pointer 5*/
#define SRCP6   (*(unsigned int volatile *)0xfcf8)  /* Source Pointer PECC 6 */
#define DSTP6   (*(unsigned int volatile *)0xfcfa)  /* Destination Pointer 6 */
#define SRCP7   (*(unsigned int volatile *)0xfcfc)  /* Source Pointer PECC 7 */
#define DSTP7   (*(unsigned int volatile *)0xfcfe)  /* Destination Pointer 7 */

/* BUSCON Registers */

#define  BUSCON0   (*(unsigned int volatile *)0xff0c)  /* */
#define  BUSCON1   (*(unsigned int volatile *)0xff14)  /* */
#define  BUSCON2   (*(unsigned int volatile *)0xff16)  /* */
#define  BUSCON3   (*(unsigned int volatile *)0xff18)  /* */
#define  BUSCON4   (*(unsigned int volatile *)0xff1a)  /* */

#define  ADDRSEL1  (*(unsigned int volatile *)0xfe18)  /* */
#define  ADDRSEL2  (*(unsigned int volatile *)0xfe1a)  /* */
#define  ADDRSEL3  (*(unsigned int volatile *)0xfe1c)  /* */
#define  ADDRSEL4  (*(unsigned int volatile *)0xfe1e)  /* */

/* miscellanious */
#if !(defined C165 || defined __C165__)
#define  PWMCON0   (*(unsigned int volatile *)0xff30)  /* */
#define  PWMCON1   (*(unsigned int volatile *)0xff32)  /* */
#define  PWMIC     (*(unsigned int volatile *)0xf17e)  /* */

#define  PW0       (*(unsigned int volatile *)0xfe30)  /* */
#define  PW1       (*(unsigned int volatile *)0xfe32)  /* */
#define  PW2       (*(unsigned int volatile *)0xfe34)  /* */
#define  PW3       (*(unsigned int volatile *)0xfe36)  /* */

#define  PT0       (*(unsigned int volatile *)0xf030)  /* */
#define  PT1       (*(unsigned int volatile *)0xf032)  /* */
#define  PT2       (*(unsigned int volatile *)0xf034)  /* */
#define  PT3       (*(unsigned int volatile *)0xf036)  /* */

#define  PP0       (*(unsigned int volatile *)0xf038)  /* */
#define  PP1       (*(unsigned int volatile *)0xf03a)  /* */
#define  PP2       (*(unsigned int volatile *)0xf03c)  /* */
#define  PP3       (*(unsigned int volatile *)0xf03e)  /* */
#endif

#define  EXICON    (*(unsigned int volatile *)0xf1c0)  /* */

#define  SSCBR     (*(unsigned int volatile *)0xf0b4)  /* */
#define  SSCCON    (*(unsigned int volatile *)0xffb2)  /* */
#define  SSCTIC    (*(unsigned int volatile *)0xff72)  /* */
#define  SSCRIC    (*(unsigned int volatile *)0xff74)  /* */
#define  SSCEIC    (*(unsigned int volatile *)0xff76)  /* */

#define  SSCTB     (*(unsigned int volatile *)0xf0b0)  /* */
#define  SSCRB     (*(unsigned int volatile *)0xf0b2)  /* */

#define  RP0H      (*(unsigned int volatile *)0xf108)  /* */

#define  XP0IC     (*(unsigned int volatile *)0xf186)  /* */
#define  XP1IC     (*(unsigned int volatile *)0xf18e)  /* */
#define  XP2IC     (*(unsigned int volatile *)0xf196)  /* */
#define  XP3IC     (*(unsigned int volatile *)0xf19e)  /* */

#endif    /* defined C166 && defined C167 */



