/*   RCS $Id: ctype.h,v 1.4 1997/10/06 12:29:51 c166 Rel c166 $							*/
/*
**  ctype.h  for Siemens C16x -- character test macros           
**
**  Adapted by HighTec EDV-Systeme GmbH (FF)
**
**     @(#) ctype.h  3.1  01/28/95  
**
*/
   
#ifndef _ctype_h
#define _ctype_h
   
#define _U 01
#define _L 02
#define _N 04
#define _S 010
#define _P 020
#define _C 040

#define _X 0100
#define _B 0200


#define CTYPE_TYPE	const char

#ifdef __cplusplus
extern "C" {
#endif
extern	CTYPE_TYPE	_ctype_[];
#ifdef __cplusplus
}
#endif
   
#define isalpha(c)  ((_ctype_+1)[c]&(_U|_L))
#define isupper(c)  ((_ctype_+1)[c]&_U)
#define islower(c)  ((_ctype_+1)[c]&_L)
#define isdigit(c)  ((_ctype_+1)[c]&_N)
#define isxdigit(c) ((_ctype_+1)[c]&(_X|_N))
#define isspace(c)  ((_ctype_+1)[c]&_S)
#define ispunct(c)  ((_ctype_+1)[c]&_P)
#define isalnum(c)  ((_ctype_+1)[c]&(_U|_L|_N))
#define isprint(c)  ((_ctype_+1)[c]&(_P|_U|_L|_N|_B))
#define isgraph(c)  ((_ctype_+1)[c]&(_P|_U|_L|_N))
#define iscntrl(c)  ((_ctype_+1)[c]&_C)
#define isascii(c)  ((unsigned)(c)<=0177)
#define toupper(c)  (islower(c)? (c-'a'+'A') : c)
#define tolower(c)  (isupper(c)? (c-'A'+'a') : c)
#define toascii(c)  ((c)&0177)


#ifdef _ctype_
#undef _ctype_
#endif

#ifdef CTYPE_TYPE
#undef CTYPE_TYPE
#endif

#endif  /* _ctype_h */
