/*   RCS $Id: float.h,v 1.4 1997/10/06 12:29:51 c166 Rel c166 $							*/
/*
**  float.h  for SAB C16x -- constants for floating point ranges 
**
**  Adapted by HighTec EDV-Systeme GmbH 
** 
**  $RCSfile: float.h,v $$Revision: 1.4 $$Date: 1997/10/06 12:29:51 $
*/

 
#ifndef _float_h_
#define _float_h_
 
#define FLT_RADIX    (2)
#define FLT_ROUNDS   (1)
 
#define FLT_MAX             (1.7014117331926428e+38)
#define FLT_MIN             (2.9387358770557188e-38)
#define FLT_EPSILON  	(1.1920928955078125e-7)
#define FLT_DIG             (6)
#define FLT_MANT_DIG 	(24)
#define FLT_MIN_EXP  	(-125)
#define FLT_MAX_EXP  	(128)
#define FLT_MIN_10_EXP      (-37)
#define FLT_MAX_10_EXP      (38)
 
#define DBL_MAX             (1.7976931348623158e+308)
#define DBL_MIN             (2.2250738585072014e-308)
#define DBL_EPSILON  	(2.2204460492503131e-16)
#define DBL_DIG             (15)
#define DBL_MANT_DIG 	(53)
#define DBL_MIN_EXP  	(-1021)
#define DBL_MAX_EXP  	(1024)
#define DBL_MIN_10_EXP      (-307)
#define DBL_MAX_10_EXP      (308)
 
#define LDBL_MAX     	DBL_MAX
#define LDBL_MIN     	DBL_MIN
#define LDBL_DIG     	DBL_DIG
#define LDBL_MANT_DIG       DBL_MANT_DIG
#define LDBL_EPSILON 	DBL_EPSILON
#define LDBL_MIN_EXP 	DBL_MIN_EXP
#define LDBL_MAX_EXP 	DBL_MAX_EXP
#define LDBL_MIN_10_EXP     DBL_MIN_10_EXP
#define LDBL_MAX_10_EXP     DBL_MAX_10_EXP
 
#endif
 

