/*   RCS $Id: limits.h,v 1.4 1997/10/06 12:29:51 c166 Rel c166 $							*/
/*
**  limits.h  for SAB C16x -- constants for integer ranges 
**
**  Adapted by HighTec EDV-Systeme GmbH 
** 
**  $RCSfile: limits.h,v $$Revision: 1.4 $$Date: 1997/10/06 12:29:51 $
*/

#ifndef _limits_h_
#define _limits_h_ 

#define CHAR_BIT	(8)

#ifdef __CHAR_UNSIGNED__
#define       CHAR_MIN      UCHAR_MIN
#define       CHAR_MAX      UCHAR_MAX
#else
#define       CHAR_MIN      SCHAR_MIN
#define       CHAR_MAX      SCHAR_MAX
#endif
 

#define SCHAR_MAX	(0x7f)
#define SCHAR_MIN	(0x80)
#define UCHAR_MAX	(0xff)
#define UCHAR_MIN	(0x00)

#define SHRT_MAX	(0x7fff)
#define SHRT_MIN	(0x8000)
#define USHRT_MAX	(0xffff)
#define USHRT_MIN	(0x0000)

#define INT_MAX	SHRT_MAX
#define INT_MIN	SHRT_MIN
#define UINT_MAX	USHRT_MAX
#define UINT_MIN	USHRT_MIN

#define LONG_MAX 	(0x7fffffff)
#define LONG_MIN 	(0x80000000)
#define ULONG_MAX 	(0xffffffff)
#define ULONG_MIN 	(0x00000000)

#endif
