/*   RCS $Id: std.h,v 1.4 1997/10/06 12:29:51 c166 Rel c166 $							*/
/*
**  std.h  for Siemens C16x -- C library functions prototypes      
**
**  Adapted by HighTec EDV-Systeme GmbH (FF)
**
**      @(#) std.h  3.1  01/28/95  
**
*/



#ifndef _std_h
#define _std_h 1

#if (!defined NULL)
#define NULL 0
#endif 

#ifndef _SIZE_T
#define _SIZE_T
typedef  unsigned int  size_t ;
#endif


#ifdef __cplusplus
extern "C" {
#endif

double     atof(const char*);
int        atoi(const char*);
long       atol(const char*);

char*      strcat(char *, const char*);
char*      strchr(const char*, int);
int        strcmp(const char*, const char*);
char*      strcpy(char*, const char*);
int        strcspn(const char*, const char*);
int        strlen(const char*);
char*      strncat(char*, const char*, int);
int        strncmp(const char*, const char*, int);
char*      strncpy(char*, const char*, int);
char*      strpbrk(const char*, const char*);
char*      strrchr(const char*, int);
int        strspn(const char*, const char*);
char*      strstr(const char*, const char*);
char*      strtok(char*, const char*);

double     strtod(const char*, char**);
long       strtol(const char*, char**, int);
unsigned long  strtoul(const char*, char**, int);

void*	   memchr(const void*, unsigned char, int);
int 	   memcmp(const void*, const void*, int);
void* 	   memcpy(void *, const void *, int);
void* 	   memmove(void *, const void *, int);
void*     memset(void *, int, int);

char *	   malloc (unsigned int);
void	   free (char *);

int	   rand(void);
void	   srand(unsigned int);
void      qsort (void *, size_t, size_t , int (*)(const void *, const void *));
void *    bsearch( const void *, const void *, size_t , size_t,
                   int (*)( const void *, const void * ));

#if (defined __OPTIMIZE__ )
static __inline__ int  abs(int arg)   { return (arg < 0? -arg : arg); }
static __inline__ long labs(long arg) { return (arg < 0? -arg : arg); }
#else
#define abs(x)       (((x) <0 ) ? -(x) : (x))
#define labs(x)      (((x) <0 ) ? -(x) : (x))
#endif

void exit  (int);
void abort (void);

void bcopy (char *, char *, int);
void far_bcopy (char far *, char far *, int);
void huge_bcopy (char huge *, char huge *, int);

void bzero (char *, int);
void far_bzero (char far *, int);
void huge_bzero (char huge *, int);

#ifdef __cplusplus
}
#endif

#endif 
