/*   RCS $Id: stdio.h,v 1.4 1997/10/06 12:29:51 c166 Rel c166 $							*/
/*
**  stdio.h  for SAB C16x -- C library buffer IO functions prototypes      
**
**  Written by HighTec EDV-Systeme GmbH (FF)
**
**
*/


#ifndef _stdio_h
#define _stdio_h 1

#if (!defined NULL)
#define NULL 0
#endif 
#include <stdarg.h>
#include <stddef.h>
#include <std.h>


#ifdef __cplusplus
extern "C" {
#endif

/* NOTE!!!  
   The (v)sscanf() and v(s)printf() functions in the C-Lib (libc_...) 
   does only supports conversions for Integer values !
   If floating point converions are needed, the corresponding flio_... 
   library (that supports Floating Point IO) must be specified when 
   linking.
   The routines with floating point conversions are more time and code 
   expensive and only available for special medium and large memory 
   models. They further need more user stack amount as well as heap, 
   since malloc() is used. Both userstack and heap size (in bytes)
   must be specified on the command line with the -ustack <size> and
   -heap <size> option. 
   
   E.g.  gcc166 -mspecmed -g tst-printf.c /usr/local/lib/flio_x.a \
	 	  -ustack 2048 -heap 512  

   
*/

int  sprintf(char *buf, char const *format, ...);
int  vsprintf(char *buf, char const *format, va_list arglist);

int  sscanf(const char *s,char const *format, ...);
int  vsscanf(const char *s,char const *format, va_list arglist);

/* helper print() function using the same serial line as GDB166 
   when debugging.
   Can be used in the way:

   char print_buf[SIZE];
   #define PRINTF(x, args...)  { sprintf (print_buf, x, ##args); \
				     serOutstring (print_buf); }
*/
int  serOutstring (char *);

#ifdef __cplusplus
}
#endif

#endif 
