@ ##############################################################################
@ # rlong0.s -- jump handler for intersegment and indirect calls on SAB C166   #
@ #            (w/o using the system stack)				       #
@ # (c) 1991 HighTec EDV-Systeme, D-6670 St. Ingbert                           #
@ # 06/27/91 (ms)                                                              #
@ # 10/12/92 (ff)   for REGPARMS                                               #
@ ##############################################################################

	.text

	.globl XHdlCall0, XHdlRet0, XLongJump0, XCallSeg0, XRetSeg0

XHdlCall0:
	jmps  seg:XHdlRet0,sof:XHdlRet0	@ jump to caller's segment
	jmps  seg:XHdlRet1,sof:XHdlRet1
	jmps  seg:XHdlRet2,sof:XHdlRet2
	jmps  seg:XHdlRet3,sof:XHdlRet3
XHdlRet0:
	mov   r8,[r0]		@ get local return address
	jmpi  cc_uc,[r8]	@ and return to caller

XLongJump0:
@	mov   r9,[r0]		@ r9 = seg:target
@	cmp   r9,csp		@ == this segment?
@	jmp   cc_ne,long0	@ no, intersegment
@	mov   r9,[r0+#2]	@ r9 = sof:target
@	jmpi  cc_uc,[r9]	@ call short

long0:	mov   [-r0],r9		@ leave space for return segment
        mov   [-r0],r9		@ save r9       
	mov   r9,csp		@ r9 = sof:return 
	mov   [r0+#2],r9	@ save it 
	mov   r9,[r0+]		@ restore r9
	shl   r8,#2		@ seg:target * 4
	add   r8,#c_tab		@ + start of jump table
	jmpi  cc_uc,[r8]	@ call segment
c_tab:	jmps  seg:XCallSeg0,sof:XCallSeg0
	jmps  seg:XCallSeg1,sof:XCallSeg1
	jmps  seg:XCallSeg2,sof:XCallSeg2
	jmps  seg:XCallSeg3,sof:XCallSeg3

XCallSeg0:
	mov   r8,#0f		@ load local return address
	jmpi  cc_uc,[r9]	@ call function
0:	mov   r8,[r0]		@ r8 = seg:caller
	shl   r8,#2		@ * 4
	add   r8,#r_tab	@ + start of return table
	jmpi  cc_uc,[r8]	@ return to old segment
r_tab:	jmps  seg:XRetSeg0,sof:XRetSeg0
	jmps  seg:XRetSeg1,sof:XRetSeg1
	jmps  seg:XRetSeg2,sof:XRetSeg2
	jmps  seg:XRetSeg3,sof:XRetSeg3

XRetSeg0:
	mov   r8,[r0+#2]	@ load caller's return address
	jmpi  cc_uc,[r8]	@ return to caller


	.globl XDummyRetSeg0

XDummyRetSeg0:			@ used for dummy calls (gdb)
	sub   r0,#4
	mov   r8,#0f
	jmpi  cc_uc,[r9]
0:	rets


	
	.globl	XGdesTrampFuncall0	@ used by GDES to call functions
	.globl	XGdesTrampFuncall0_Ret
XGdesTrampFuncall0:			@ function to be called in
					@ r8 (segment) and r9 (offset)
	sub	r0,#2			@ space for return address
	mov	[-r0],r8		@ save r8
	mov	r8,#0f
	mov	[r0 + #2], r8		@ return address
	mov	r8,[r0+]		@ restore r8
	jmp	cc_uc,XLongJumpX
0:
XGdesTrampFuncall0_Ret:
	trap	#2			@ might need to be modified, if
					@ a debugger other than GDB is
					@ used (should generate a debugger
					@ breakpoint.
	nop				@ necessary for GDB
